## fish-4.5.0.tar.xz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

project(fish LANGUAGES C)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(DEFAULT_BUILD_TYPE "RelWithDebInfo")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to default '${DEFAULT_BUILD_TYPE}'")
    set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}")
endif()

# Set up standard directories.
include(GNUInstallDirs)

# Set up PCRE2
# This sets an environment variable that needs to be available before the Rust stanzas
include(cmake/PCRE2.cmake)

include(cmake/Rust.cmake)

# Work around issue where archive-built libs go in the wrong place.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

find_program(SPHINX_EXECUTABLE NAMES sphinx-build
    HINTS
    $ENV{SPHINX_DIR}
    PATH_SUFFIXES bin
    DOC "Sphinx documentation generator")


# Tell Cargo where our build directory is so it can find Cargo.toml.
set(VARS_FOR_CARGO
    "FISH_CMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}"
    "PREFIX=${CMAKE_INSTALL_PREFIX}"
    "DOCDIR=${CMAKE_INSTALL_FULL_DOCDIR}"
    "DATADIR=${CMAKE_INSTALL_FULL_DATADIR}"
    "SYSCONFDIR=${CMAKE_INSTALL_FULL_SYSCONFDIR}"
    "BINDIR=${CMAKE_INSTALL_FULL_BINDIR}"
    "CARGO_TARGET_DIR=${FISH_RUST_BUILD_DIR}"
    "CARGO_BUILD_RUSTC=${Rust_COMPILER}"
    "${FISH_PCRE2_BUILDFLAG}"
    "FISH_SPHINX=${SPHINX_EXECUTABLE}"
)

# Let fish pick up when we're running out of the build directory without installing
get_filename_component(REAL_CMAKE_BINARY_DIR "${CMAKE_BINARY_DIR}" REALPATH)
get_filename_component(REAL_CMAKE_SOURCE_DIR "${CMAKE_SOURCE_DIR}" REALPATH)
add_definitions(-DCMAKE_BINARY_DIR="${REAL_CMAKE_BINARY_DIR}")
add_definitions(-DCMAKE_SOURCE_DIR="${REAL_CMAKE_SOURCE_DIR}")

set(build_types Release RelWithDebInfo Debug "")
if(NOT "${CMAKE_BUILD_TYPE}" IN_LIST build_types)
  message(WARNING "Unsupported build type ${CMAKE_BUILD_TYPE}. If this doesn't build, try one of Release, RelWithDebInfo or Debug")
endif()

add_custom_target(
  fish ALL
  COMMAND
    "${CMAKE_COMMAND}" -E
      env ${VARS_FOR_CARGO}
        ${Rust_CARGO}
          build --bin fish
          $<$<CONFIG:Release>:--release>
          $<$<CONFIG:RelWithDebInfo>:--profile=release-with-debug>
          --target ${Rust_CARGO_TARGET}
          --no-default-features
          --features=${FISH_CARGO_FEATURES}
          ${CARGO_FLAGS}
    &&
    "${CMAKE_COMMAND}" -E
      copy "${rust_target_dir}/${rust_profile}/fish" "${CMAKE_CURRENT_BINARY_DIR}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  USES_TERMINAL
)

function(CREATE_LINK target)
  add_custom_target(
    ${target} ALL
    DEPENDS fish
    COMMAND ln -f fish ${target}
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )
endfunction(CREATE_LINK)

# Define fish_indent.
create_link(fish_indent)

# Define fish_key_reader.
create_link(fish_key_reader)

# Set up the docs.
include(cmake/Docs.cmake)

# Set up tests.
include(cmake/Tests.cmake)

# Benchmarking support.
include(cmake/Benchmark.cmake)

# Set up install.
include(cmake/Install.cmake)

# Mac app.
include(cmake/MacApp.cmake)

include(FeatureSummary)
feature_summary(WHAT ALL)

=== contrib/debian/changelog ===
fish (4.5.0-1) stable; urgency=medium

  * Release of new version 4.5.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.5.0 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Tue, 17 Feb 2026 11:32:33 +1100

fish (4.4.0-1) stable; urgency=medium

  * Release of new version 4.4.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.4.0 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Tue, 03 Feb 2026 12:11:51 +1100

fish (4.3.3-1) stable; urgency=medium

  * Release of new version 4.3.3.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.3.3 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Wed, 07 Jan 2026 08:34:20 +0100

fish (4.3.2-1) stable; urgency=medium

  * Release of new version 4.3.2.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.3.2 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Tue, 30 Dec 2025 17:21:04 +0100

fish (4.3.1-1) stable; urgency=medium

  * Release of new version 4.3.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.3.1 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Sun, 28 Dec 2025 16:54:44 +0100

fish (4.3.0-1) stable; urgency=medium

  * Release of new version 4.3.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.3.0 for details.

 -- Johannes Altmanninger <aclopte@gmail.com>  Sun, 28 Dec 2025 10:20:47 +0100

fish (4.2.1-1) testing; urgency=medium

  * Release of new version 4.2.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.2.1 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 13 Nov 2025 20:42:43 +0800

fish (4.2.0-1) testing; urgency=medium

  * Release of new version 4.2.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.2.0 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Mon, 10 Nov 2025 19:29:03 +0800

fish (4.1.2-1) testing; urgency=medium

  * Release of new version 4.1.2.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.1.2 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Wed, 08 Oct 2025 13:46:45 +0800

fish (4.1.1-1) testing; urgency=medium

  * Release of new version 4.1.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.1.1 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Fri, 03 Oct 2025 16:43:43 +0800

fish (4.0.8-1) testing; urgency=medium

  * Release of new version 4.0.8.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.0.8 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 18 Sep 2025 22:17:43 +0800

fish (4.0.6-1) testing; urgency=medium

  * Release of new version 4.0.6.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.0.6 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Wed, 17 Sep 2025 12:27:09 +0800

fish (4.0.2-2) testing; urgency=medium

  * Fix tests on Debian.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sun, 20 Apr 2025 23:08:14 +0800

fish (4.0.2-1) testing; urgency=medium

  * Release of new version 4.0.2.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.0.2 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sun, 20 Apr 2025 21:24:18 +0800

fish (4.0.1-1) testing; urgency=medium

  * Release of new version 4.0.1.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 13 Mar 2025 11:30:21 +0800

fish (4.0.0-2) testing; urgency=medium

  * Fix tests on Debian.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 27 Feb 2025 21:50:33 +0800

fish (4.0.0-1) testing; urgency=medium

  * Release of new version 4.0.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/4.0.0 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 27 Feb 2025 19:22:30 +0800

fish (3.7.1-1) testing; urgency=medium

  * Release of new version 3.7.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.7.1 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Tue, 19 Mar 2024 13:26:22 +0800

fish (3.7.0-1) testing; urgency=medium

  * Release of new version 3.7.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.7.0 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Mon, 01 Jan 2024 23:32:55 +0800

fish (3.6.4-1) testing; urgency=medium

  * Release of new version 3.6.4.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.4 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Tue, 05 Dec 2023 22:34:09 +0800

fish (3.6.3-1) testing; urgency=medium

  * Release of new version 3.6.3.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.3 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Tue, 05 Dec 2023 00:11:12 +0800

fish (3.6.2-1) testing; urgency=medium

  * Release of new version 3.6.2.
  * Includes a fix for CVE-2023-49284.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.2 for details.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Mon, 04 Dec 2023 23:16:42 +0800

fish (3.6.1-1) testing; urgency=medium

  * Release of new version 3.6.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.1 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sat, 25 Mar 2023 17:22:12 +0800

fish (3.6.0-1) testing; urgency=medium

  * Release of new version 3.6.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.0 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sat, 07 Jan 2023 22:41:32 +0800

fish (3.5.1-1) testing; urgency=medium

  * Release of new version 3.5.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.5.1 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Wed, 20 Jul 2022 21:54:09 +0800

fish (3.5.0-1) testing; urgency=medium

  * Release of new version 3.5.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.5.0 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 16 Jun 2022 19:45:33 +0800

fish (3.4.0-1) testing; urgency=medium

  * Release of new version 3.4.0.



=== contrib/debian/control ===
Source: fish
Section: shells
Priority: optional
Maintainer: ridiculous_fish <corydoras@ridiculousfish.com>
Uploaders: David Adam <zanchey@ucc.gu.uwa.edu.au>
Build-Depends: debhelper-compat (= 13),
# -web is for Debian's updated version, -X.Y is for Ubuntu's backported versions
 cargo (>= 1.85) | cargo-web (>= 1.85) | cargo-1.85,
 cmake (>= 3.15.0),
 gettext,
 libpcre2-dev,
 rustc (>= 1.85) | rustc-web (>= 1.85) | rustc-1.85,
 python3-sphinx,
# Test dependencies
 locales-all,
 man-db,
 python3
# 4.6.2 is Debian 12/Ubuntu Noble 24.04; Ubuntu Jammy is 4.6.0.1
Standards-Version: 4.6.2
Homepage: https://fishshell.com/
Vcs-Git: https://github.com/fish-shell/fish-shell.git
Vcs-Browser: https://github.com/fish-shell/fish-shell

Package: fish
Architecture: any
# for col and lock
Depends: bsdextrautils,
 file,
# for man
 man-db,
# for kill
 procps,
 python3 (>=3.5),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts: fish-common
Recommends: xsel (>=1.2.0)
Suggests: xdg-utils
Description: friendly interactive shell
 Fish is a command-line shell for modern systems, focusing on user-friendliness,
 sensibility and discoverability in interactive use. The syntax is simple, but
 not POSIX compliant.

=== contrib/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
  export DH_VERBOSE=1
  # VERBOSE to satisfy Debian policy 4.9, introduced in version 4.2.0
  export CARGO_TERM_VERBOSE=true
endif
# The LTO profile sets CFLAGS/CXXFLAGS which confuse the compilation process; disable it
# LTO is still performed by rustc based on Cargo.toml
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

%:
	dh $@ --buildsystem=cmake --builddirectory=build

# Setting the build system is still required, because otherwise the GNUmakefile gets picked up
override_dh_auto_configure:
	ln -s cargo-vendor/vendor vendor
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	  -DRust_CARGO=$$(command -v cargo-1.85 || command -v cargo) \
	  -DRust_COMPILER=$$(command -v rustc-1.85 || command -v rustc)

override_dh_clean:
	dh_clean --exclude=Cargo.toml.orig
	-unlink vendor

override_dh_auto_test:
	cd build && make fish_run_tests
